<center><a href="gr2.c">Actual source code: gr2.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:33:17+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCDM_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/* </font>
<a name="line4">  4: </a><font color="#B22222">   Plots vectors obtained with <A href="../../../../docs/manualpages/DA/DACreate2d.html#DACreate2d">DACreate2d</A>()</font>
<a name="line5">  5: </a><font color="#B22222">*/</font>

<a name="line7"> 7: </a> #include <A href="../../../../src/dm/da/daimpl.h.html">src/dm/da/daimpl.h</A>
<a name="line8"> 8: </a> #include <A href="../../../../include/private/vecimpl.h.html">private/vecimpl.h</A>

<a name="line10"> 10: </a><font color="#A020F0">#if defined(PETSC_HAVE_PNETCDF)</font>
<a name="line12"> 12: </a><font color="#A020F0">#include </font><font color="#666666">"pnetcdf.h"</font><font color="#A020F0"></font>
<a name="line14"> 14: </a><font color="#A020F0">#endif</font>


<a name="line17"> 17: </a><font color="#B22222">/*</font>
<a name="line18"> 18: </a><font color="#B22222">        The data that is passed into the graphics callback</font>
<a name="line19"> 19: </a><font color="#B22222">*/</font>
<a name="line20"> 20: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line21"> 21: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>     m,n,step,k;
<a name="line22"> 22: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>    min,max,scale;
<a name="line23"> 23: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>  *xy,*v;
<a name="line24"> 24: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>   showgrid;
<a name="line25"> 25: </a>} ZoomCtx;

<a name="line27"> 27: </a><font color="#B22222">/*</font>
<a name="line28"> 28: </a><font color="#B22222">       This does the drawing for one particular field </font>
<a name="line29"> 29: </a><font color="#B22222">    in one particular set of coordinates. It is a callback</font>
<a name="line30"> 30: </a><font color="#B22222">    called from <A href="../../../../docs/manualpages/Draw/PetscDrawZoom.html#PetscDrawZoom">PetscDrawZoom</A>()</font>
<a name="line31"> 31: </a><font color="#B22222">*/</font>
<a name="line34"> 34: </a><strong><font color="#4169E1"><a name="VecView_MPI_Draw_DA2d_Zoom"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> VecView_MPI_Draw_DA2d_Zoom(<A href="../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw,void *ctx)</font></strong>
<a name="line35"> 35: </a>{
<a name="line36"> 36: </a>  ZoomCtx        *zctx = (ZoomCtx*)ctx;
<a name="line38"> 38: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       m,n,i,j,k,step,id,c1,c2,c3,c4;
<a name="line39"> 39: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      s,min,x1,x2,x3,x4,y_1,y2,y3,y4;
<a name="line40"> 40: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>   *v,*xy;

<a name="line43"> 43: </a>  m    = zctx-&gt;m;
<a name="line44"> 44: </a>  n    = zctx-&gt;n;
<a name="line45"> 45: </a>  step = zctx-&gt;step;
<a name="line46"> 46: </a>  k    = zctx-&gt;k;
<a name="line47"> 47: </a>  v    = zctx-&gt;v;
<a name="line48"> 48: </a>  xy   = zctx-&gt;xy;
<a name="line49"> 49: </a>  s    = zctx-&gt;scale;
<a name="line50"> 50: </a>  min  = zctx-&gt;min;
<a name="line51"> 51: </a>
<a name="line52"> 52: </a>  <font color="#B22222">/* <A href="../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> the contour plot patch */</font>
<a name="line53"> 53: </a>  <font color="#4169E1">for</font> (j=0; j&lt;n-1; j++) {
<a name="line54"> 54: </a>    <font color="#4169E1">for</font> (i=0; i&lt;m-1; i++) {
<a name="line55"> 55: </a><font color="#A020F0">#if !defined(PETSC_USE_COMPLEX)</font>
<a name="line56"> 56: </a>      id = i+j*m;    x1 = xy[2*id];y_1 = xy[2*id+1];c1 = (int)(PETSC_DRAW_BASIC_COLORS+s*(v[k+step*id]-min));
<a name="line57"> 57: </a>      id = i+j*m+1;  x2 = xy[2*id];y2  = y_1;       c2 = (int)(PETSC_DRAW_BASIC_COLORS+s*(v[k+step*id]-min));
<a name="line58"> 58: </a>      id = i+j*m+1+m;x3 = x2;      y3  = xy[2*id+1];c3 = (int)(PETSC_DRAW_BASIC_COLORS+s*(v[k+step*id]-min));
<a name="line59"> 59: </a>      id = i+j*m+m;  x4 = x1;      y4  = y3;        c4 = (int)(PETSC_DRAW_BASIC_COLORS+s*(v[k+step*id]-min));
<a name="line60"> 60: </a><font color="#A020F0">#else</font>
<a name="line61"> 61: </a>      id = i+j*m;    x1 = PetscRealPart(xy[2*id]);y_1 = PetscRealPart(xy[2*id+1]);c1 = (int)(PETSC_DRAW_BASIC_COLORS+s*(PetscRealPart(v[k+step*id])-min));
<a name="line62"> 62: </a>      id = i+j*m+1;  x2 = PetscRealPart(xy[2*id]);y2  = y_1;       c2 = (int)(PETSC_DRAW_BASIC_COLORS+s*(PetscRealPart(v[k+step*id])-min));
<a name="line63"> 63: </a>      id = i+j*m+1+m;x3 = x2;      y3  = PetscRealPart(xy[2*id+1]);c3 = (int)(PETSC_DRAW_BASIC_COLORS+s*(PetscRealPart(v[k+step*id])-min));
<a name="line64"> 64: </a>      id = i+j*m+m;  x4 = x1;      y4  = y3;        c4 = (int)(PETSC_DRAW_BASIC_COLORS+s*(PetscRealPart(v[k+step*id])-min));
<a name="line65"> 65: </a><font color="#A020F0">#endif</font>
<a name="line66"> 66: </a>      <A href="../../../../docs/manualpages/Draw/PetscDrawTriangle.html#PetscDrawTriangle">PetscDrawTriangle</A>(draw,x1,y_1,x2,y2,x3,y3,c1,c2,c3);
<a name="line67"> 67: </a>      <A href="../../../../docs/manualpages/Draw/PetscDrawTriangle.html#PetscDrawTriangle">PetscDrawTriangle</A>(draw,x1,y_1,x3,y3,x4,y4,c1,c3,c4);
<a name="line68"> 68: </a>      <font color="#4169E1">if</font> (zctx-&gt;showgrid) {
<a name="line69"> 69: </a>        <A href="../../../../docs/manualpages/Draw/PetscDrawLine.html#PetscDrawLine">PetscDrawLine</A>(draw,x1,y_1,x2,y2,PETSC_DRAW_BLACK);
<a name="line70"> 70: </a>        <A href="../../../../docs/manualpages/Draw/PetscDrawLine.html#PetscDrawLine">PetscDrawLine</A>(draw,x2,y2,x3,y3,PETSC_DRAW_BLACK);
<a name="line71"> 71: </a>        <A href="../../../../docs/manualpages/Draw/PetscDrawLine.html#PetscDrawLine">PetscDrawLine</A>(draw,x3,y3,x4,y4,PETSC_DRAW_BLACK);
<a name="line72"> 72: </a>        <A href="../../../../docs/manualpages/Draw/PetscDrawLine.html#PetscDrawLine">PetscDrawLine</A>(draw,x4,y4,x1,y_1,PETSC_DRAW_BLACK);
<a name="line73"> 73: </a>      }
<a name="line74"> 74: </a>    }
<a name="line75"> 75: </a>  }
<a name="line76"> 76: </a>  <font color="#4169E1">return</font>(0);
<a name="line77"> 77: </a>}

<a name="line81"> 81: </a><strong><font color="#4169E1"><a name="VecView_MPI_Draw_DA2d"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> VecView_MPI_Draw_DA2d(<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xin,<A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line82"> 82: </a>{
<a name="line83"> 83: </a>  <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>                 da,dac,dag;
<a name="line84"> 84: </a>  <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>     ierr;
<a name="line85"> 85: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>        <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line86"> 86: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>           igstart,N,s,M,istart,isize,jgstart,*lx,*ly,w;
<a name="line87"> 87: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>          coors[4],ymin,ymax,xmin,xmax;
<a name="line88"> 88: </a>  <A href="../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A>          draw,popup;
<a name="line89"> 89: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>         isnull,useports;
<a name="line90"> 90: </a>  <A href="../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A>           <A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>;
<a name="line91"> 91: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>                xlocal,xcoor,xcoorl;
<a name="line92"> 92: </a>  <A href="../../../../docs/manualpages/DA/DAPeriodicType.html#DAPeriodicType">DAPeriodicType</A>     periodic;
<a name="line93"> 93: </a>  <A href="../../../../docs/manualpages/DA/DAStencilType.html#DAStencilType">DAStencilType</A>      st;
<a name="line94"> 94: </a>  ZoomCtx            zctx;
<a name="line95"> 95: </a>  <A href="../../../../docs/manualpages/Draw/PetscDrawViewPorts.html#PetscDrawViewPorts">PetscDrawViewPorts</A> *ports;
<a name="line96"> 96: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerFormat.html#PetscViewerFormat">PetscViewerFormat</A>  format;

<a name="line99"> 99: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawGetDraw.html#PetscViewerDrawGetDraw">PetscViewerDrawGetDraw</A>(viewer,0,&amp;draw);
<a name="line100">100: </a>  <A href="../../../../docs/manualpages/Draw/PetscDrawIsNull.html#PetscDrawIsNull">PetscDrawIsNull</A>(draw,&amp;isnull); <font color="#4169E1">if</font> (isnull) <font color="#4169E1">return</font>(0);

<a name="line102">102: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectQuery.html#PetscObjectQuery">PetscObjectQuery</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin,<font color="#666666">"<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>*)&amp;da);
<a name="line103">103: </a>  <font color="#4169E1">if</font> (!da) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONG,<font color="#666666">"Vector not generated from a <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>);

<a name="line105">105: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectGetComm.html#PetscObjectGetComm">PetscObjectGetComm</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin,&amp;<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>);
<a name="line106">106: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);

<a name="line108">108: </a>  <A href="../../../../docs/manualpages/DA/DAGetInfo.html#DAGetInfo">DAGetInfo</A>(da,0,&amp;M,&amp;N,0,&amp;zctx.m,&amp;zctx.n,0,&amp;w,&amp;s,&amp;periodic,&amp;st);
<a name="line109">109: </a>  DAGetOwnershipRange(da,&amp;lx,&amp;ly,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line111">111: </a>  <font color="#B22222">/* </font>
<a name="line112">112: </a><font color="#B22222">        Obtain a sequential vector that is going to contain the local values plus ONE layer of </font>
<a name="line113">113: </a><font color="#B22222">     ghosted values to draw the graphics from. We also need its corresponding <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> (dac) that will</font>
<a name="line114">114: </a><font color="#B22222">     update the local values pluse ONE layer of ghost values. </font>
<a name="line115">115: </a><font color="#B22222">  */</font>
<a name="line116">116: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectQuery.html#PetscObjectQuery">PetscObjectQuery</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)da,<font color="#666666">"GraphicsGhosted"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>*)&amp;xlocal);
<a name="line117">117: </a>  <font color="#4169E1">if</font> (!xlocal) {
<a name="line118">118: </a>    <font color="#4169E1">if</font> (periodic != DA_NONPERIODIC || s != 1 || st != DA_STENCIL_BOX) {
<a name="line119">119: </a>      <font color="#B22222">/* </font>
<a name="line120">120: </a><font color="#B22222">         if original da is not of stencil width one, or periodic or not a box stencil then</font>
<a name="line121">121: </a><font color="#B22222">         create a special <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> to handle one level of ghost points for graphics</font>
<a name="line122">122: </a><font color="#B22222">      */</font>
<a name="line123">123: </a>      <A href="../../../../docs/manualpages/DA/DACreate2d.html#DACreate2d">DACreate2d</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,DA_NONPERIODIC,DA_STENCIL_BOX,M,N,zctx.m,zctx.n,w,1,lx,ly,&amp;dac);
<a name="line124">124: </a>      <A href="../../../../docs/manualpages/Profiling/PetscInfo.html#PetscInfo">PetscInfo</A>(da,<font color="#666666">"Creating auxilary <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> for managing graphics ghost points\n"</font>);
<a name="line125">125: </a>    } <font color="#4169E1">else</font> {
<a name="line126">126: </a>      <font color="#B22222">/* otherwise we can use the da we already have */</font>
<a name="line127">127: </a>      dac = da;
<a name="line128">128: </a>    }
<a name="line129">129: </a>    <font color="#B22222">/* create local vector for holding ghosted values used in graphics */</font>
<a name="line130">130: </a>    <A href="../../../../docs/manualpages/DA/DACreateLocalVector.html#DACreateLocalVector">DACreateLocalVector</A>(dac,&amp;xlocal);
<a name="line131">131: </a>    <font color="#4169E1">if</font> (dac != da) {
<a name="line132">132: </a>      <font color="#B22222">/* don't keep any public reference of this <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>, is is only available through xlocal */</font>
<a name="line133">133: </a>      <A href="../../../../docs/manualpages/DA/DADestroy.html#DADestroy">DADestroy</A>(dac);
<a name="line134">134: </a>    } <font color="#4169E1">else</font> {
<a name="line135">135: </a>      <font color="#B22222">/* remove association between xlocal and da, because below we compose in the opposite</font>
<a name="line136">136: </a><font color="#B22222">         direction and if we left this connect we'd get a loop, so the objects could </font>
<a name="line137">137: </a><font color="#B22222">         never be destroyed */</font>
<a name="line138">138: </a>      <A href="../../../../docs/manualpages/Sys/PetscObjectCompose.html#PetscObjectCompose">PetscObjectCompose</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xlocal,<font color="#666666">"<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>,0);
<a name="line139">139: </a>    }
<a name="line140">140: </a>    <A href="../../../../docs/manualpages/Sys/PetscObjectCompose.html#PetscObjectCompose">PetscObjectCompose</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)da,<font color="#666666">"GraphicsGhosted"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xlocal);
<a name="line141">141: </a>    <A href="../../../../docs/manualpages/Sys/PetscObjectDereference.html#PetscObjectDereference">PetscObjectDereference</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xlocal);
<a name="line142">142: </a>  } <font color="#4169E1">else</font> {
<a name="line143">143: </a>    <font color="#4169E1">if</font> (periodic == DA_NONPERIODIC &amp;&amp; s == 1 &amp;&amp; st == DA_STENCIL_BOX) {
<a name="line144">144: </a>      dac = da;
<a name="line145">145: </a>    } <font color="#4169E1">else</font> {
<a name="line146">146: </a>      <A href="../../../../docs/manualpages/Sys/PetscObjectQuery.html#PetscObjectQuery">PetscObjectQuery</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xlocal,<font color="#666666">"<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>*)&amp;dac);
<a name="line147">147: </a>    }
<a name="line148">148: </a>  }

<a name="line150">150: </a>  <font color="#B22222">/*</font>
<a name="line151">151: </a><font color="#B22222">      Get local (ghosted) values of vector</font>
<a name="line152">152: </a><font color="#B22222">  */</font>
<a name="line153">153: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(dac,xin,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,xlocal);
<a name="line154">154: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>(dac,xin,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,xlocal);
<a name="line155">155: </a>  <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(xlocal,&amp;zctx.v);

<a name="line157">157: </a>  <font color="#B22222">/* get coordinates of nodes */</font>
<a name="line158">158: </a>  <A href="../../../../docs/manualpages/DA/DAGetCoordinates.html#DAGetCoordinates">DAGetCoordinates</A>(da,&amp;xcoor);
<a name="line159">159: </a>  <font color="#4169E1">if</font> (!xcoor) {
<a name="line160">160: </a>    <A href="../../../../docs/manualpages/DA/DASetUniformCoordinates.html#DASetUniformCoordinates">DASetUniformCoordinates</A>(da,0.0,1.0,0.0,1.0,0.0,0.0);
<a name="line161">161: </a>    <A href="../../../../docs/manualpages/DA/DAGetCoordinates.html#DAGetCoordinates">DAGetCoordinates</A>(da,&amp;xcoor);
<a name="line162">162: </a>  }

<a name="line164">164: </a>  <font color="#B22222">/*</font>
<a name="line165">165: </a><font color="#B22222">      Determine the min and max  coordinates in plot </font>
<a name="line166">166: </a><font color="#B22222">  */</font>
<a name="line167">167: </a>  <A href="../../../../docs/manualpages/Vec/VecStrideMin.html#VecStrideMin">VecStrideMin</A>(xcoor,0,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;xmin);
<a name="line168">168: </a>  <A href="../../../../docs/manualpages/Vec/VecStrideMax.html#VecStrideMax">VecStrideMax</A>(xcoor,0,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;xmax);
<a name="line169">169: </a>  <A href="../../../../docs/manualpages/Vec/VecStrideMin.html#VecStrideMin">VecStrideMin</A>(xcoor,1,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;ymin);
<a name="line170">170: </a>  <A href="../../../../docs/manualpages/Vec/VecStrideMax.html#VecStrideMax">VecStrideMax</A>(xcoor,1,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;ymax);
<a name="line171">171: </a>  coors[0] = xmin - .05*(xmax- xmin); coors[2] = xmax + .05*(xmax - xmin);
<a name="line172">172: </a>  coors[1] = ymin - .05*(ymax- ymin); coors[3] = ymax + .05*(ymax - ymin);
<a name="line173">173: </a>  PetscInfo4(da,<font color="#666666">"Preparing <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> 2d contour plot coordinates %G %G %G %G\n"</font>,coors[0],coors[1],coors[2],coors[3]);

<a name="line175">175: </a>  <font color="#B22222">/*</font>
<a name="line176">176: </a><font color="#B22222">       get local ghosted version of coordinates </font>
<a name="line177">177: </a><font color="#B22222">  */</font>
<a name="line178">178: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectQuery.html#PetscObjectQuery">PetscObjectQuery</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)da,<font color="#666666">"GraphicsCoordinateGhosted"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>*)&amp;xcoorl);
<a name="line179">179: </a>  <font color="#4169E1">if</font> (!xcoorl) {
<a name="line180">180: </a>    <font color="#B22222">/* create <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> to get local version of graphics */</font>
<a name="line181">181: </a>    <A href="../../../../docs/manualpages/DA/DACreate2d.html#DACreate2d">DACreate2d</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,DA_NONPERIODIC,DA_STENCIL_BOX,M,N,zctx.m,zctx.n,2,1,lx,ly,&amp;dag);
<a name="line182">182: </a>    <A href="../../../../docs/manualpages/Profiling/PetscInfo.html#PetscInfo">PetscInfo</A>(dag,<font color="#666666">"Creating auxilary <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> for managing graphics coordinates ghost points\n"</font>);
<a name="line183">183: </a>    <A href="../../../../docs/manualpages/DA/DACreateLocalVector.html#DACreateLocalVector">DACreateLocalVector</A>(dag,&amp;xcoorl);
<a name="line184">184: </a>    <A href="../../../../docs/manualpages/Sys/PetscObjectCompose.html#PetscObjectCompose">PetscObjectCompose</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)da,<font color="#666666">"GraphicsCoordinateGhosted"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xcoorl);
<a name="line185">185: </a>    <A href="../../../../docs/manualpages/DA/DADestroy.html#DADestroy">DADestroy</A>(dag);<font color="#B22222">/* dereference dag */</font>
<a name="line186">186: </a>    <A href="../../../../docs/manualpages/Sys/PetscObjectDereference.html#PetscObjectDereference">PetscObjectDereference</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xcoorl);
<a name="line187">187: </a>  } <font color="#4169E1">else</font> {
<a name="line188">188: </a>    <A href="../../../../docs/manualpages/Sys/PetscObjectQuery.html#PetscObjectQuery">PetscObjectQuery</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xcoorl,<font color="#666666">"<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>*)&amp;dag);
<a name="line189">189: </a>  }
<a name="line190">190: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(dag,xcoor,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,xcoorl);
<a name="line191">191: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>(dag,xcoor,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,xcoorl);
<a name="line192">192: </a>  <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(xcoorl,&amp;zctx.xy);
<a name="line193">193: </a>
<a name="line194">194: </a>  <font color="#B22222">/*</font>
<a name="line195">195: </a><font color="#B22222">        Get information about <A href="../../../../docs/manualpages/Sys/size.html#size">size</A> of area each processor must do graphics for</font>
<a name="line196">196: </a><font color="#B22222">  */</font>
<a name="line197">197: </a>  <A href="../../../../docs/manualpages/DA/DAGetInfo.html#DAGetInfo">DAGetInfo</A>(dac,0,&amp;M,&amp;N,0,0,0,0,&amp;zctx.step,0,&amp;periodic,0);
<a name="line198">198: </a>  <A href="../../../../docs/manualpages/DA/DAGetGhostCorners.html#DAGetGhostCorners">DAGetGhostCorners</A>(dac,&amp;igstart,&amp;jgstart,0,&amp;zctx.m,&amp;zctx.n,0);
<a name="line199">199: </a>  <A href="../../../../docs/manualpages/DA/DAGetCorners.html#DAGetCorners">DAGetCorners</A>(dac,&amp;istart,0,0,&amp;isize,0,0);

<a name="line201">201: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-draw_contour_grid"</font>,&amp;zctx.showgrid);

<a name="line203">203: </a>  PetscViewerGetFormat(viewer,&amp;format);
<a name="line204">204: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-draw_ports"</font>,&amp;useports);
<a name="line205">205: </a>  <font color="#4169E1">if</font> (useports || format == PETSC_VIEWER_DRAW_PORTS){
<a name="line206">206: </a>    <A href="../../../../docs/manualpages/Draw/PetscDrawSynchronizedClear.html#PetscDrawSynchronizedClear">PetscDrawSynchronizedClear</A>(draw);
<a name="line207">207: </a>    <A href="../../../../docs/manualpages/Draw/PetscDrawViewPortsCreate.html#PetscDrawViewPortsCreate">PetscDrawViewPortsCreate</A>(draw,zctx.step,&amp;ports);
<a name="line208">208: </a>  }
<a name="line209">209: </a>  <font color="#B22222">/*</font>
<a name="line210">210: </a><font color="#B22222">     Loop over each field; drawing each in a different window</font>
<a name="line211">211: </a><font color="#B22222">  */</font>
<a name="line212">212: </a>  <font color="#4169E1">for</font> (zctx.k=0; zctx.k&lt;zctx.step; zctx.k++) {
<a name="line213">213: </a>    <font color="#4169E1">if</font> (useports) {
<a name="line214">214: </a>      <A href="../../../../docs/manualpages/Draw/PetscDrawViewPortsSet.html#PetscDrawViewPortsSet">PetscDrawViewPortsSet</A>(ports,zctx.k);
<a name="line215">215: </a>    } <font color="#4169E1">else</font> {
<a name="line216">216: </a>      <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawGetDraw.html#PetscViewerDrawGetDraw">PetscViewerDrawGetDraw</A>(viewer,zctx.k,&amp;draw);
<a name="line217">217: </a>      <A href="../../../../docs/manualpages/Draw/PetscDrawSynchronizedClear.html#PetscDrawSynchronizedClear">PetscDrawSynchronizedClear</A>(draw);
<a name="line218">218: </a>    }

<a name="line220">220: </a>    <font color="#B22222">/*</font>
<a name="line221">221: </a><font color="#B22222">        Determine the min and max color in plot </font>
<a name="line222">222: </a><font color="#B22222">    */</font>
<a name="line223">223: </a>    <A href="../../../../docs/manualpages/Vec/VecStrideMin.html#VecStrideMin">VecStrideMin</A>(xin,zctx.k,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;zctx.min);
<a name="line224">224: </a>    <A href="../../../../docs/manualpages/Vec/VecStrideMax.html#VecStrideMax">VecStrideMax</A>(xin,zctx.k,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;zctx.max);
<a name="line225">225: </a>    <font color="#4169E1">if</font> (zctx.min == zctx.max) {
<a name="line226">226: </a>      zctx.min -= 1.e-12;
<a name="line227">227: </a>      zctx.max += 1.e-12;
<a name="line228">228: </a>    }

<a name="line230">230: </a>    <font color="#4169E1">if</font> (!<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>) {
<a name="line231">231: </a>      char *title;

<a name="line233">233: </a>      <A href="../../../../docs/manualpages/DA/DAGetFieldName.html#DAGetFieldName">DAGetFieldName</A>(da,zctx.k,&amp;title);
<a name="line234">234: </a>      <font color="#4169E1">if</font> (title) {
<a name="line235">235: </a>        <A href="../../../../docs/manualpages/Draw/PetscDrawSetTitle.html#PetscDrawSetTitle">PetscDrawSetTitle</A>(draw,title);
<a name="line236">236: </a>      }
<a name="line237">237: </a>    }
<a name="line238">238: </a>    <A href="../../../../docs/manualpages/Draw/PetscDrawSetCoordinates.html#PetscDrawSetCoordinates">PetscDrawSetCoordinates</A>(draw,coors[0],coors[1],coors[2],coors[3]);
<a name="line239">239: </a>    PetscInfo2(da,<font color="#666666">"<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> 2d contour plot min %G max %G\n"</font>,zctx.min,zctx.max);

<a name="line241">241: </a>    <A href="../../../../docs/manualpages/Draw/PetscDrawGetPopup.html#PetscDrawGetPopup">PetscDrawGetPopup</A>(draw,&amp;popup);
<a name="line242">242: </a>    <font color="#4169E1">if</font> (popup) {<A href="../../../../docs/manualpages/Draw/PetscDrawScalePopup.html#PetscDrawScalePopup">PetscDrawScalePopup</A>(popup,zctx.min,zctx.max);}

<a name="line244">244: </a>    zctx.scale = (245.0 - PETSC_DRAW_BASIC_COLORS)/(zctx.max - zctx.min);

<a name="line246">246: </a>    <A href="../../../../docs/manualpages/Draw/PetscDrawZoom.html#PetscDrawZoom">PetscDrawZoom</A>(draw,VecView_MPI_Draw_DA2d_Zoom,&amp;zctx);
<a name="line247">247: </a>  }
<a name="line248">248: </a>  <font color="#4169E1">if</font> (useports){
<a name="line249">249: </a>    <A href="../../../../docs/manualpages/Draw/PetscDrawViewPortsDestroy.html#PetscDrawViewPortsDestroy">PetscDrawViewPortsDestroy</A>(ports);
<a name="line250">250: </a>  }

<a name="line252">252: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(xcoorl,&amp;zctx.xy);
<a name="line253">253: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(xlocal,&amp;zctx.v);
<a name="line254">254: </a>  <font color="#4169E1">return</font>(0);
<a name="line255">255: </a>}

<a name="line257">257: </a><strong><font color="#4169E1">EXTERN <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> VecView_MPI_HDF4_Ex(<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> X, <A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer, <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> d, <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *dims)</font></strong>;

<a name="line259">259: </a><font color="#A020F0">#if defined(PETSC_HAVE_HDF4)</font>
<a name="line262">262: </a><strong><font color="#4169E1"><a name="VecView_MPI_HDF4_DA2d"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> VecView_MPI_HDF4_DA2d(<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xin,<A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line263">263: </a>{
<a name="line265">265: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       dims[2];
<a name="line266">266: </a>  <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>             da;
<a name="line267">267: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            natural;


<a name="line271">271: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectQuery.html#PetscObjectQuery">PetscObjectQuery</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin,<font color="#666666">"<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>*)&amp;da);
<a name="line272">272: </a>  <font color="#4169E1">if</font> (!da) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONG,<font color="#666666">"Vector not generated from a <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>);

<a name="line274">274: </a>  dims[0] = da-&gt;M;
<a name="line275">275: </a>  dims[1] = da-&gt;N;

<a name="line277">277: </a>  <A href="../../../../docs/manualpages/DA/DACreateNaturalVector.html#DACreateNaturalVector">DACreateNaturalVector</A>(da,&amp;natural);
<a name="line278">278: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToNaturalBegin.html#DAGlobalToNaturalBegin">DAGlobalToNaturalBegin</A>(da,xin,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,natural);
<a name="line279">279: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToNaturalEnd.html#DAGlobalToNaturalEnd">DAGlobalToNaturalEnd</A>(da,xin,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,natural);
<a name="line280">280: </a>  VecView_MPI_HDF4_Ex(natural, viewer, 2, dims);
<a name="line281">281: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(natural);
<a name="line282">282: </a>  <font color="#4169E1">return</font>(0);
<a name="line283">283: </a>}
<a name="line284">284: </a><font color="#A020F0">#endif</font>

<a name="line286">286: </a><font color="#A020F0">#if defined(PETSC_HAVE_PNETCDF)</font>
<a name="line289">289: </a><strong><font color="#4169E1"><a name="VecView_MPI_Netcdf_DA"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> VecView_MPI_Netcdf_DA(<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xin,<A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line290">290: </a>{
<a name="line292">292: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       ncid,xstart,xdim_num=1;
<a name="line293">293: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       dim,m,n,p,dof,swidth,M,N,P;
<a name="line294">294: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       xin_dim,xin_id,xin_n,xin_N,xyz_dim,xyz_id,xyz_n,xyz_N;
<a name="line295">295: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       *lx,*ly,*lz;
<a name="line296">296: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *xarray;
<a name="line297">297: </a>  <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>             da,dac;
<a name="line298">298: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            natural,xyz;
<a name="line299">299: </a>  <A href="../../../../docs/manualpages/DA/DAStencilType.html#DAStencilType">DAStencilType</A>  stencil;
<a name="line300">300: </a>  <A href="../../../../docs/manualpages/DA/DAPeriodicType.html#DAPeriodicType">DAPeriodicType</A> periodic;
<a name="line301">301: </a>  <A href="../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A>       <A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>;

<a name="line304">304: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectGetComm.html#PetscObjectGetComm">PetscObjectGetComm</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin,&amp;<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>);
<a name="line305">305: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectQuery.html#PetscObjectQuery">PetscObjectQuery</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin,<font color="#666666">"<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>*)&amp;da);
<a name="line306">306: </a>  <font color="#4169E1">if</font> (!da) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONG,<font color="#666666">"Vector not generated from a <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>);
<a name="line307">307: </a>  <A href="../../../../docs/manualpages/DA/DAGetInfo.html#DAGetInfo">DAGetInfo</A>(da,&amp;dim,&amp;m,&amp;n,&amp;p,&amp;M,&amp;N,&amp;P,&amp;dof,&amp;swidth,&amp;periodic,&amp;stencil);

<a name="line309">309: </a>  <font color="#B22222">/* create the appropriate <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> to map the coordinates to natural ordering */</font>
<a name="line310">310: </a>  DAGetOwnershipRange(da,&amp;lx,&amp;ly,&amp;lz);
<a name="line311">311: </a>  <font color="#4169E1">if</font> (dim == 1) {
<a name="line312">312: </a>    <A href="../../../../docs/manualpages/DA/DACreate1d.html#DACreate1d">DACreate1d</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,DA_NONPERIODIC,m,dim,0,lx,&amp;dac);
<a name="line313">313: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (dim == 2) {
<a name="line314">314: </a>    <A href="../../../../docs/manualpages/DA/DACreate2d.html#DACreate2d">DACreate2d</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,DA_NONPERIODIC,DA_STENCIL_BOX,m,n,M,N,dim,0,lx,ly,&amp;dac);
<a name="line315">315: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (dim == 3) {
<a name="line316">316: </a>    <A href="../../../../docs/manualpages/DA/DACreate3d.html#DACreate3d">DACreate3d</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,DA_NONPERIODIC,DA_STENCIL_BOX,m,n,p,M,N,P,dim,0,lx,ly,lz,&amp;dac);
<a name="line317">317: </a>  } <font color="#4169E1">else</font> {
<a name="line318">318: </a>    <A href="../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_ARG_CORRUPT,<font color="#666666">"Dimension is not 1 2 or 3: %D\n"</font>,dim);
<a name="line319">319: </a>  }
<a name="line320">320: </a>  <A href="../../../../docs/manualpages/DA/DACreateNaturalVector.html#DACreateNaturalVector">DACreateNaturalVector</A>(dac,&amp;xyz);
<a name="line321">321: </a>  PetscObjectSetOptionsPrefix((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xyz,<font color="#666666">"coor_"</font>);
<a name="line322">322: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToNaturalBegin.html#DAGlobalToNaturalBegin">DAGlobalToNaturalBegin</A>(dac,da-&gt;coordinates,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,xyz);
<a name="line323">323: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToNaturalEnd.html#DAGlobalToNaturalEnd">DAGlobalToNaturalEnd</A>(dac,da-&gt;coordinates,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,xyz);
<a name="line324">324: </a>  <font color="#B22222">/* Create the <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> vector in natural ordering */</font>
<a name="line325">325: </a>  <A href="../../../../docs/manualpages/DA/DACreateNaturalVector.html#DACreateNaturalVector">DACreateNaturalVector</A>(da,&amp;natural);
<a name="line326">326: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToNaturalBegin.html#DAGlobalToNaturalBegin">DAGlobalToNaturalBegin</A>(da,xin,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,natural);
<a name="line327">327: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToNaturalEnd.html#DAGlobalToNaturalEnd">DAGlobalToNaturalEnd</A>(da,xin,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,natural);
<a name="line328">328: </a>  <font color="#B22222">/* Write the netCDF dataset */</font>
<a name="line329">329: </a>  PetscViewerNetcdfGetID(viewer,&amp;ncid);
<a name="line330">330: </a>  <font color="#4169E1">if</font> (ncid &lt; 0) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ORDER,<font color="#666666">"First call PetscViewerNetcdfOpen to create NetCDF dataset"</font>);
<a name="line331">331: </a>  <font color="#B22222">/* define dimensions */</font>
<a name="line332">332: </a>  <A href="../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(xin,&amp;xin_N);
<a name="line333">333: </a>  <A href="../../../../docs/manualpages/Vec/VecGetLocalSize.html#VecGetLocalSize">VecGetLocalSize</A>(xin,&amp;xin_n);
<a name="line334">334: </a>  ncmpi_def_dim(ncid,<font color="#666666">"PETSc_DA_Vector_Global_Size"</font>,xin_N,&amp;xin_dim);
<a name="line335">335: </a>  <A href="../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(xyz,&amp;xyz_N);
<a name="line336">336: </a>  <A href="../../../../docs/manualpages/Vec/VecGetLocalSize.html#VecGetLocalSize">VecGetLocalSize</A>(xyz,&amp;xyz_n);
<a name="line337">337: </a>  ncmpi_def_dim(ncid,<font color="#666666">"PETSc_DA_Coordinate_Vector_Global_Size"</font>,xyz_N,&amp;xyz_dim);
<a name="line338">338: </a>  <font color="#B22222">/* define variables */</font>
<a name="line339">339: </a>  ncmpi_def_var(ncid,<font color="#666666">"PETSc_DA_Vector"</font>,NC_DOUBLE,xdim_num,&amp;xin_dim,&amp;xin_id);
<a name="line340">340: </a>  ncmpi_def_var(ncid,<font color="#666666">"PETSc_DA_Coordinate_Vector"</font>,NC_DOUBLE,xdim_num,&amp;xyz_dim,&amp;xyz_id);
<a name="line341">341: </a>  <font color="#B22222">/* leave define mode */</font>
<a name="line342">342: </a>  ncmpi_enddef(ncid);
<a name="line343">343: </a>  <font color="#B22222">/* store the vector */</font>
<a name="line344">344: </a>  <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(xin,&amp;xarray);
<a name="line345">345: </a>  <A href="../../../../docs/manualpages/Vec/VecGetOwnershipRange.html#VecGetOwnershipRange">VecGetOwnershipRange</A>(xin,&amp;xstart,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line346">346: </a>  ncmpi_put_vara_double_all(ncid,xin_id,(const MPI_Offset*)&amp;xstart,(const MPI_Offset*)&amp;xin_n,xarray);
<a name="line347">347: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(xin,&amp;xarray);
<a name="line348">348: </a>  <font color="#B22222">/* store the coordinate vector */</font>
<a name="line349">349: </a>  <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(xyz,&amp;xarray);
<a name="line350">350: </a>  <A href="../../../../docs/manualpages/Vec/VecGetOwnershipRange.html#VecGetOwnershipRange">VecGetOwnershipRange</A>(xyz,&amp;xstart,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line351">351: </a>  ncmpi_put_vara_double_all(ncid,xyz_id,(const MPI_Offset*)&amp;xstart,(const MPI_Offset*)&amp;xyz_n,xarray);
<a name="line352">352: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(xyz,&amp;xarray);
<a name="line353">353: </a>  <font color="#B22222">/* destroy the vectors and da */</font>
<a name="line354">354: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(natural);
<a name="line355">355: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(xyz);
<a name="line356">356: </a>  <A href="../../../../docs/manualpages/DA/DADestroy.html#DADestroy">DADestroy</A>(dac);
<a name="line357">357: </a>  <font color="#4169E1">return</font>(0);
<a name="line358">358: </a>}
<a name="line359">359: </a><font color="#A020F0">#endif</font>

<a name="line361">361: </a><strong><font color="#4169E1">EXTERN <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> VecView_MPI_Draw_DA1d(<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>)</font></strong>;

<a name="line366">366: </a><strong><font color="#4169E1"><a name="VecView_MPI_DA"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  VecView_MPI_DA(<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xin,<A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line367">367: </a>{
<a name="line368">368: </a>  <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>             da;
<a name="line370">370: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       dim;
<a name="line371">371: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            natural;
<a name="line372">372: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     isdraw;
<a name="line373">373: </a><font color="#A020F0">#if defined(PETSC_HAVE_HDF4)</font>
<a name="line374">374: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     ishdf4;
<a name="line375">375: </a><font color="#A020F0">#endif</font>
<a name="line376">376: </a><font color="#A020F0">#if defined(PETSC_HAVE_PNETCDF)</font>
<a name="line377">377: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     isnetcdf;
<a name="line378">378: </a><font color="#A020F0">#endif</font>
<a name="line379">379: </a>  const char     *prefix;

<a name="line382">382: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectQuery.html#PetscObjectQuery">PetscObjectQuery</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin,<font color="#666666">"<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>*)&amp;da);
<a name="line383">383: </a>  <font color="#4169E1">if</font> (!da) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONG,<font color="#666666">"Vector not generated from a <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>);
<a name="line384">384: </a>  <A href="../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,PETSC_VIEWER_DRAW,&amp;isdraw);
<a name="line385">385: </a><font color="#A020F0">#if defined(PETSC_HAVE_HDF4)</font>
<a name="line386">386: </a>  <A href="../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,PETSC_VIEWER_HDF4,&amp;ishdf4);
<a name="line387">387: </a><font color="#A020F0">#endif</font>
<a name="line388">388: </a><font color="#A020F0">#if defined(PETSC_HAVE_PNETCDF)</font>
<a name="line389">389: </a>  <A href="../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,PETSC_VIEWER_NETCDF,&amp;isnetcdf);
<a name="line390">390: </a><font color="#A020F0">#endif</font>
<a name="line391">391: </a>  <font color="#4169E1">if</font> (isdraw) {
<a name="line392">392: </a>    <A href="../../../../docs/manualpages/DA/DAGetInfo.html#DAGetInfo">DAGetInfo</A>(da,&amp;dim,0,0,0,0,0,0,0,0,0,0);
<a name="line393">393: </a>    <font color="#4169E1">if</font> (dim == 1) {
<a name="line394">394: </a>      VecView_MPI_Draw_DA1d(xin,viewer);
<a name="line395">395: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (dim == 2) {
<a name="line396">396: </a>      VecView_MPI_Draw_DA2d(xin,viewer);
<a name="line397">397: </a>    } <font color="#4169E1">else</font> {
<a name="line398">398: </a>      <A href="../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_SUP,<font color="#666666">"Cannot graphically view vector associated with this dimensional <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> %D"</font>,dim);
<a name="line399">399: </a>    }
<a name="line400">400: </a><font color="#A020F0">#if defined(PETSC_HAVE_HDF4)</font>
<a name="line401">401: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (ishdf4) {
<a name="line402">402: </a>    <A href="../../../../docs/manualpages/DA/DAGetInfo.html#DAGetInfo">DAGetInfo</A>(da,&amp;dim,0,0,0,0,0,0,0,0,0,0);
<a name="line403">403: </a>    <font color="#4169E1">switch</font> (dim) {
<a name="line404">404: </a>    <font color="#4169E1">case</font> 2:
<a name="line405">405: </a>      VecView_MPI_HDF4_DA2d(xin,viewer);
<a name="line406">406: </a>      <font color="#4169E1">break</font>;
<a name="line407">407: </a><strong><font color="#FF0000">    default:</font></strong>
<a name="line408">408: </a>      <A href="../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_SUP,<font color="#666666">"Cannot view HDF4 vector associated with this dimensional <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A> %D"</font>,dim);
<a name="line409">409: </a>    }
<a name="line410">410: </a><font color="#A020F0">#endif</font>
<a name="line411">411: </a><font color="#A020F0">#if defined(PETSC_HAVE_PNETCDF)</font>
<a name="line412">412: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (isnetcdf) {
<a name="line413">413: </a>    VecView_MPI_Netcdf_DA(xin,viewer);
<a name="line414">414: </a><font color="#A020F0">#endif</font>
<a name="line415">415: </a>  } <font color="#4169E1">else</font> {
<a name="line416">416: </a>    <font color="#B22222">/* call viewer on natural ordering */</font>
<a name="line417">417: </a>    PetscObjectGetOptionsPrefix((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin,&amp;prefix);
<a name="line418">418: </a>    <A href="../../../../docs/manualpages/DA/DACreateNaturalVector.html#DACreateNaturalVector">DACreateNaturalVector</A>(da,&amp;natural);
<a name="line419">419: </a>    PetscObjectSetOptionsPrefix((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)natural,prefix);
<a name="line420">420: </a>    <A href="../../../../docs/manualpages/DA/DAGlobalToNaturalBegin.html#DAGlobalToNaturalBegin">DAGlobalToNaturalBegin</A>(da,xin,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,natural);
<a name="line421">421: </a>    <A href="../../../../docs/manualpages/DA/DAGlobalToNaturalEnd.html#DAGlobalToNaturalEnd">DAGlobalToNaturalEnd</A>(da,xin,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,natural);
<a name="line422">422: </a>    <A href="../../../../docs/manualpages/Sys/PetscObjectName.html#PetscObjectName">PetscObjectName</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin);
<a name="line423">423: </a>    <A href="../../../../docs/manualpages/Sys/PetscObjectSetName.html#PetscObjectSetName">PetscObjectSetName</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)natural,xin-&gt;name);
<a name="line424">424: </a>    <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(natural,viewer);
<a name="line425">425: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(natural);
<a name="line426">426: </a>  }
<a name="line427">427: </a>  <font color="#4169E1">return</font>(0);
<a name="line428">428: </a>}

<a name="line434">434: </a><strong><font color="#4169E1"><a name="VecLoadIntoVector_Binary_DA"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  VecLoadIntoVector_Binary_DA(<A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xin)</font></strong>
<a name="line435">435: </a>{
<a name="line436">436: </a>  <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>             da;
<a name="line438">438: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            natural;
<a name="line439">439: </a>  const char     *prefix;

<a name="line442">442: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectQuery.html#PetscObjectQuery">PetscObjectQuery</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin,<font color="#666666">"<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>,(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>*)&amp;da);
<a name="line443">443: </a>  <font color="#4169E1">if</font> (!da) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONG,<font color="#666666">"Vector not generated from a <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>"</font>);
<a name="line444">444: </a>  PetscObjectGetOptionsPrefix((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)xin,&amp;prefix);
<a name="line445">445: </a>  <A href="../../../../docs/manualpages/DA/DACreateNaturalVector.html#DACreateNaturalVector">DACreateNaturalVector</A>(da,&amp;natural);
<a name="line446">446: </a>  PetscObjectSetOptionsPrefix((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)natural,prefix);
<a name="line447">447: </a>  <A href="../../../../docs/manualpages/Vec/VecLoadIntoVector.html#VecLoadIntoVector">VecLoadIntoVector</A>(viewer,natural);
<a name="line448">448: </a>  <A href="../../../../docs/manualpages/DA/DANaturalToGlobalBegin.html#DANaturalToGlobalBegin">DANaturalToGlobalBegin</A>(da,natural,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,xin);
<a name="line449">449: </a>  <A href="../../../../docs/manualpages/DA/DANaturalToGlobalEnd.html#DANaturalToGlobalEnd">DANaturalToGlobalEnd</A>(da,natural,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,xin);
<a name="line450">450: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(natural);
<a name="line451">451: </a>  <A href="../../../../docs/manualpages/Profiling/PetscInfo.html#PetscInfo">PetscInfo</A>(xin,<font color="#666666">"Loading vector from natural ordering into <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>\n"</font>);
<a name="line452">452: </a>  <font color="#4169E1">return</font>(0);
<a name="line453">453: </a>}
</pre>
</body>

</html>
